 ;Adobe Helvetica normal
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/LINIEY.inc"
;%include "./INC/linie.inc"
;%include "./INC/outnc2.3.inc"

;buf			resb	25
;Deltax		dd	0		;Schritte X
;Deltay		dd	0		;Schritte Y
;Deltaz		dd	0		;Schritte Z
;Linex		dd	0		;Aktueller X-Wert der Linie
;Liney		dd	0		;Aktueller Y-Wert der Linie
;Linez		dd	0		;Aktueller Z-Wert der Linie

;Linedev		db	0		;Liniendefiniton
;Bit	2 1 0	
;	x x 0		nach	rechts	+
;	x x 1		nach links		-
;	x 0 x		nach	hinten	+
;	x 1 x		nach	vorne	-
;	0 x x		nach	oben		+
;	1 x x		nach	unten		-
;-------------------------------------------------

LINIEY:
section .text

	mov	eax,3
	mov	ebx,[datnum]
	mov	ecx,buf
	mov	edx,6
	int	80h
	cmp	eax,6
	jz	.a
	call	error1
	jmp	Ende
.a:
	mov	dword[Linex],0
	mov	dword[Liney],0
	mov	dword[Linez],0
	mov	al,[buf]
	test	al,00001000b		;ob relativ
	jnz	.ay1				;wenn 1 = absolut
	jmp	.b
.ay1:						;--- absolut ---
	mov	ecx,1000000000	
	sub	ecx,[Y]			;ecx = Y_ist - Y_soll
	jc	.ay4
						;--- (+) Y_ist ---
	test	al,00000010b
	jz	.ay2				;ob R_soll = 0  (+)
	add	[buf+1],ecx			;R_soll (-)
	jmp	.b				;R(-)  (+ -)
.ay2:
	sub	ecx,[buf+1]			;Y_ist - Y_soll
	jnc	.ay3
	neg	ecx
	mov	[buf+1], ecx
	jmp	.b				;R(+)  (+ +)
.ay3:
	mov	[buf+1],ecx
	or	al,00000010b
	jmp	.b				;R(-)  (+ +)

.ay4:						;--- (-) Y_ist ---
	neg	ecx
	test	al,00000010b
	jnz	.ay5				;wenn R_soll = 1  (-)
	add	[buf+1],ecx			;R == (+)
	jmp	.b				;R (+)  (- +)
	
.ay5:						;R == (-)
	sub	ecx,[buf+1]			;Y_ist - Y_soll
	jnc	.ay6
	neg	ecx
	mov	[buf+1],ecx
	jmp	.b				;R (-)  (- -)
.ay6:
	and	al,11111101b
	mov	[buf+1],ecx			;R (+)  (- -)

.b:
	mov	[Linedev],al
	mov	eax,[buf+1]
	cmp	eax,0
	jz	.ende
	mov	[Deltay],eax
	mov	dword[Deltax],0
	mov	dword[Deltaz],0
	
	mov	ecx,0				;b ecx wird in brechner gesetzt
	mov	byte[statusB],cl		;b statusB zurcksetzen
.b1:
	call	brechner			;b setzt Delay
	call	linie
	call	outnc
	mov	eax,[Liney]			;b Line_ = Position
	mov	cl,[statusB]			;b neue Stufe in ecx
	add	eax,ecx			;b zum addieren
	cmp	eax,[Deltay]			;b kann bis Ende gebremst werden
	jnz	.b2				;b
	or	byte[statusB],10000000b	;b remsen
.b2:						;b
	mov	eax,[Deltay]
	cmp	eax,[Liney]
	jnz	.b1
.ende:
	mov	al,[buf+5]
	ret


