;Adobe Helvetica normal
;-------------------------------------------------
;Beschleunigt die Achsen 
;-------------------------------------------------
;Accelerates the axles.
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/brechner.inc"

;Delay		dd	0		;momentaner Geschwindigkeitskoefizient
;sollDelay		dd	0		;zu erreichender Endgeschwindigkeitskoefizient
;BWert		dd	0		;Geschwindigkeitskoefizient der Beschleunigung zum 1.Schritt
;-------------------------------------------------
;BWert = ( Timer(1 000 000) * mf_basis(0.01 mm) * 60s(min) ) / ( beschl.(mm/min) * mf )
;BWert : + = beschleunigen, - = bremsen
;-------------------------------------------------
;statusB		db	0		;Status der Beschleunigung
;
; ~~~~0000		zurckgesetzt - Anfang einer Funktion
; ~~~~0001		1. Stufe, lansam
; ~~~~0010		2. Stufe
; ~~~~0011		3. Stufe
;         ...     		...  ...
; ~~~~1111		15. Stufe, schnell
; 0~~~~~~~		beschleunigen
; 1~~~~~~~		bremsen
;-------------------------------------------------
;Gebremst wird bei: SchritteBisEnde - statusB = 0

brechner:
section .data

.vmax		db	0	;ja / nein

section .text

	mov	cl,[statusB]
	test	cl,10000000b
	jnz	.bremsen

;beschleunigen:
	cmp	byte[.vmax],1
	jnz	.a5
	ret
.a5:
	mov	eax,[BWert]
	shr	eax,cl
	cmp	eax,[sollDelay]	;ob eax schneller ist als sollDelay
	ja	.a10
	mov	eax,[sollDelay]	;schneller, benutze sollDelay
	mov	[Delay],eax
	mov	byte[.vmax],1	;vmax / sollDelay is erreicht
	ret				;statusB darf nicht erhöt werden
.a10:
	mov	[Delay],eax		;langsamer, kann benutzt werden
	inc	byte[statusB]
	ret
	
.bremsen:
	mov	byte[.vmax],0
	mov	eax,[BWert]
	and	cl,1111111b
	dec	cl
	shr	eax,cl
	cmp	eax,[sollDelay]
	jae	.b5
	mov	eax,[sollDelay]	;nicht von schneller als vmax bremsen
.b5:
	mov	[Delay],eax		;Delay setzen
	dec	byte[statusB]	;Vorschub vermindern
	ret
	
	