; pcnc - Copyright (C) 2004 Sebastian Beck <sebastian.bw@freenet.de>


section .data

msg			db	'Steuerung beendet',10,0
lmsg			equ	$-msg

t1			db	' Multicore-Steuerung !',10,\
				' Die Steuerung darf nicht im selben Kern mit einem Event-Handler laufen !',10,\
				' Haben Sie alles Abgespeichert, fals das System sich aufhaengt ?',10,\
				' Sie koenen das Fraesprogramm waerend der Arbeit mit der Taste "B" abbrechen.',10,\
				' Jetzt Starten -> RETURN.',10,0
lt1			equ	$-t1

datname		db	'nc.tmp',0
nameschleifdat	db	's.tmp',0

schleifdat		dd	0			;Dateinummer zur Speicherung der Schleifen
priority		dd	0			;max priority
Sekunden		dd	0			;0 - 2147483648
Millisekunden	dd	100000000		;0 - 999 999 999
saveint		db	0			;Maskregister sichern
Key			dw	0
Bewegung		db	1
Delay		dd	500
sollDelay		dd	500			;zu erreichender Endgeschwindigkeitskoefizient
BWert		dd	30000		;Geschwindigkeitskoefizient der Beschleunigung zum 1.Schritt
statusB		db	0			;Status der Beschleunigung
X			dd	1000000000	;Werkstck-X-Position
Y			dd	1000000000	;Werkstck-Y-Position
Z			dd	1000000000	;Werkstck-Z-Position
Kreisx		dd	0			;X-Wert auf der Kreislinie
Kreisy		dd	0			;Y-Wert auf der Kreislinie
Kreisz		dd	0			;Z-Wert auf der Kreislinie
Radius		dd	0
kreisdev		db	0
Wert			dd	0,0			;value	-unchanged
Teiler			dd	0,0			;divider	-unchanged
Ergebnis		dd	0,0			;result
Ellipsx		dd	0			;X-Wert auf der Ellipse
Ellipsy		dd	0			;Y-Wert auf der Ellipse
Ellipsz		dd	0			;Z-Wert auf der Ellipse
Akreisx		dd	0			;X-Wert auf dem Au�nkreis
Akreisy		dd	0			;Y-Wert auf dem Au�nkreis
Akreisz		dd	0			;Z-Wert auf dem Au�nkreis
Radius1		dd	0			;Innenkreis
Radius2		dd	0			;Aussen
Sector		dd	0			;45-Tangenten-Schnittpunktes
ellipsdev		db	0	
Deltax		dd	0			;Laenge X
Deltay		dd	0			;Laenge Y
Deltaz		dd	0			;Laenge Z
Linex			dd	0			;Aktueller X-Wert der Linie
Liney			dd	0			;Aktueller Y-Wert der Linie
Linez			dd	0			;Aktueller Z-Wert der Linie
Linedev		db	0			;Liniendefiniton
Spielx		db	5			;Spiel der X-Achse
Spiely		db	5			;Spiel der Y-Achse
Spielz		db	0			;Spiel der Z-Achse - fr Rundtisch
Praezision		dd	0			;Unterbrechung fuer SCHLEIFE
datnum		dd	0			;Dateinummer
Deltaellips		dd	0,0			;=die Veroegderung von Ellipsx,Ellipsy nach einer Pr�ision
Deltakreis		dd	0,0			;=die Veroegderung von Kreisx,Kreisy nach einer Pr�ision
Delta			dd	0,0			;=die Veroegderung

section .bss
buf			resb	30			;Puffer fr die Befehlskette aus der Datei
buf1			resb	28			; holen und veraendern von Terminal attributes
buf2			resb	28			; speichern und wiederherstellen von Terminal attributes


section .text
global _start                      		;must be declared for linker (ld)

%include "./INC-light//div64.inc"
%include "./INC-light//Taste.inc"
%include "./INC-light//kreis-1.4.inc"
%include "./INC-light//sleep.inc"
%include "./INC-light//sqrt64.inc"
%include "./INC-light//makekreisdev.inc"
%include "./INC-light/linie.inc"
%include "./INC-light/outnc-2.7.inc"
%include "./INC-light/KREIS.inc"
%include "./INC-light/LINIE.inc"
%include "./INC-light/LINIEX.inc"
%include "./INC-light/LINIEY.inc"
%include "./INC-light/LINIEZ.inc"
%include "./INC-light/SCHLEIFE.inc"
%include "./INC-light/WARTE.inc"
%include "./INC-light/SPIEL.inc"
%include "./INC-light/verteiler.inc"
%include "./INC-light/STEUERUNG_mc.inc"
%include "./INC-light/dokey.inc"
%include "./INC-light/VORSCHUB.inc"
%include "./INC-light/stdout.inc"
%include "./INC-light/nameout.inc"
%include "./INC-light/writexyz.inc"
%include "./INC-light/error.inc"
%include "./INC-light/error1.inc"
%include "./INC-light/makesys_mc.inc"
%include "./INC-light/warte.inc"
%include "./INC-light/WERKZEUGWECHSEL.inc"
%include "./INC-light/MEMO.inc"
%include "./INC-light/BESCHLEUNIGUNG.inc"
%include "./INC-light/brechner.inc"
%include "./INC-light/WRP.inc"
%include "./INC-light/SCHLEIFENSATZ.inc"
%include "./INC-light/SPRINGE.inc"
%include "./INC-light/FRAGE.inc"
%include "./INC-light/BEDINGUNG.inc"

_start:

	call	makesys		;macht alle Vorbereitungen
	call	verteiler		;Haupschleife
ende:
	mov	edx,lmsg
	mov	ecx,msg
	mov	ebx,1
	mov	eax,4
	int	$80

	mov	eax,1
	int	$80
;-------------------------------------
